/*
 * This file contains generic C code to print call chains, assuming
 * you have GCC >= 2. It is neither pretty nor (space and time)
 * efficient. On some architectures it could be terribly inefficient,
 * e.g. on a sparc, each expansion of __builtin_return_address()
 * might flush the register windows.
 *
 * It is therefore preferable to have an architecture specific version
 * of mprbt(). For a hint on how to do this, you could examine the
 * assembly source listing produced for function mprbt().
 */

#if __GNUC__ < 2
#error you need gcc >= 2 to use this abomination
#endif

#undef ulong
#define ulong unsigned long

extern int mprprint(int, char *, ...);

#define printpc(n)					\
	if ((pc = (ulong)__builtin_return_address(n)))	\
		mprprint(fd, "%U:", pc);		\
	else						\
		return;

void
mprbt(int fd)
{
	ulong pc;

	printpc( 0); printpc( 1); printpc( 2); printpc( 3); printpc( 4);
	printpc( 5); printpc( 6); printpc( 7); printpc( 8); printpc( 9);
	printpc(10); printpc(11); printpc(12); printpc(13); printpc(14);
	printpc(15); printpc(16); printpc(17); printpc(18); printpc(19);
	printpc(20); printpc(21); printpc(22); printpc(23); printpc(24);
	printpc(25); printpc(26); printpc(27); printpc(28); printpc(29);
	printpc(30); printpc(31); printpc(32); printpc(33); printpc(34);
	printpc(35); printpc(36); printpc(37); printpc(38); printpc(39);
}
